﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dynamicweb.Extensibility;
using Dynamicweb.Ecommerce.LiveIntegration.Configuration;
using Dynamicweb.Extensibility.Notifications;

namespace Dynamicweb.Ecommerce.LiveIntegration.NotificationSubscribers
{
    [Subscribe(Dynamicweb.Notifications.Standard.User.OnExtranetLogin)]
    public class ExtranetLogin : NotificationSubscriber
    {
        public override int Rank => 1000;

        public override void OnNotify(string notification, NotificationArgs args)
        {
            if (Configuration.Global.IsIntegrationActive)
            {    
                //Used to load the cart and apply the discount after the user logged-in and has not empty cart
                var myArgs = (Dynamicweb.Notifications.Standard.User.OnExtranetLoginArgs)args;

                if (myArgs.User != null)
                {
                    UrlHandler.Instance.ClearCachedUrl();
                }

                Dynamicweb.Ecommerce.Orders.Order order = Dynamicweb.Ecommerce.Common.Context.Cart;
                if (myArgs.User != null && order != null && order.IsCart)
                {
                    if ((string.IsNullOrEmpty(Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path, Constants.WebServiceConfiguration.Shop)) ||
    Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path, Constants.WebServiceConfiguration.Shop) == (String)Dynamicweb.Frontend.PageView.Current().Area.EcomShopId)
                        && UrlHandler.Instance.IsWebServiceUrlFound())
                    {
                        OrderHandler.UpdateOrder(order);
                    }
                }
            }
        }
    }
}
